** program:  PW2
** Written:  02/24/91
** Purpose:  Provide password encryption/decription example
** Source :  Old programs
**
** Note   :  Using a little more encryption makes breaking passwords 
**           all that much harder <g>!
**
**           The concept I like to use is one whereby a "like" character
**           will not necessarily appear the same when used multiple times.
**           It is accomplished here by encrypting on it's relative position,
**           whether it is odd or even, and it's validity as an encrypted 
**           number (ie: CHR(1) thru CHR(255)).
**
** ALSO    : This scheme is intended for use with standard keyboard entries
**           only, therefore, one must "layoff" using ALT-<###> combinations
**           for password entries.
**
**
** NOTE2   : This is slightly modified version of PASSWORD.prg
**           which allows usage of fields up to 255 characters in length.
**
**           The first encoded character contains the coded trimmed length
**           of the variable to be coded.  
**           (Can be used to save memory file space <g>)

PROCEDURE PW2
   clear
   set talk off
   SET STAT OFF
   i=0
   CLEAR
   KEYBOARD "15"+chr(13)+"AAAA1111AA"+chr(13)
   @ 1,10 to 3,68
   @ 2,12 say '          First off, an interesting demo.'
   do while i<>27
      ln_Space = 10
      @ 8,10 say "Field length  : " get ln_Space pict "999"
      READ
      pw=space(ln_space)
      @ 9,10 say "Enter password: " get pw
      read
      pw1=encode(pw)
      @ 14,10 say "Encoded.......: " get pw1
      pw2 = decode(pw1)
      @ 19,10 say "Decoded.......: " get pw2
      clea gets
      SAVE SCREEN TO exitscr
      @ 24,20 say chr(7)+" Press any key to continue, Esc to quit..."
      i=inkey(0)
      CLEAR
   enddo
   set talk on
   rest screen from exitscr
   release screen exitscr
RETURN


FUNCTION encode
   param c
   ** NOTE: Encode/Decode is designed to work with fields/memvars len() < 256 
   ln_c = len(trim(c))
   ln_Counter = 0
   x=0
   lc_retval = chr(ABS(0-len(c)))
   no_1 = 10
   @ 14,27 SAY ""
   do while ln_Counter<ln_c
      x=x+1
      ln_Counter = ln_Counter + 1
      l=subs(c,ln_Counter,1)
      ln_encrypt = ;
         iif(INT(X/2)=(X/2),int(((MOD(ln_Counter,no_1))^2)),;
         iif(ln_Counter<12,iif(ln_counter<5,ln_Counter^3,ln_counter^2),;
         MOD(ln_counter-NO_1,x)))
      ln_encrypt = iif(ln_encrypt>133,133,IIF(ln_encrypt<=0,mod(ln_COUNTER+X,NO_1),ln_encrypt))
      ln_encrypt = iif(ln_encrypt=0,133-mod(ln_COUNTER+X-1,NO_1),ln_encrypt)
      ln_encrypt = iif(ln_encrypt=133,100-mod(ln_COUNTER+X+1,NO_1),ln_encrypt)
      ln_offset = asc(l)
      ln_l =asc(l) + ln_Encrypt
      x = IIF(l=" ".and.x>5,1,iif(x>12,1,x))
      lc_retval = lc_retval + chr(ln_l)
      @ 14,27 GET lc_retval COLOR ,BG+/N
      CLEAR GETS
      no_1 = iif(x=1,mod(ln_offset,9),no_1)
      no_1 = IIF(no_1=0,mod(ln_offset-1,9),no_1)
   enddo
RETURN (lc_Retval)

Function Decode
   param c
   ** NOTE: Encode/Decode is designed to work with fields/memvars len() < 256 
   ln_c = len(trim(c)) -1
   ln_expanded = ABS(0-asc(left(c,1)))
   x=0
   ln_Counter = 0
   c=right(c,ln_c)
   lc_retval = ""
   no_1 = 10
   do while ln_Counter<ln_c
      x = x+1
      ln_Counter = ln_Counter + 1
      l=subs(c,ln_Counter,1)
      ln_encrypt = ;
         iif(INT(X/2)=(X/2),int(((MOD(ln_Counter,no_1))^2)),;
         iif(ln_Counter<12,iif(ln_counter<5,ln_Counter^3,ln_counter^2),;
         MOD(ln_counter-NO_1,x)))
      ln_encrypt = iif(ln_encrypt>133,133,IIF(ln_encrypt<=0,mod(ln_Counter+X,NO_1),ln_encrypt))
      ln_encrypt = iif(ln_encrypt=0,133-mod(ln_COUNTER+X-1,NO_1),ln_encrypt)
      ln_encrypt = iif(ln_encrypt=133,100-mod(ln_COUNTER+X+1,NO_1),ln_encrypt)
      ln_l =asc(l) - ln_Encrypt
      x = IIF(chr(ln_l)=" ".and. x>5,1,iif(x>12,1,x))
      lc_retval = lc_retval + chr(ln_l)
      @ 19,27 GET lc_Retval COLOR ,BG+/N
      CLEAR GETS
      no_1 = iif(x=1,mod(ln_l,9),no_1)
      no_1 = IIF(no_1=0,mod(ln_l-1,9),no_1)
   ENDDO
RETURN (lc_RetVal + SPACE(ln_expanded-ln_c))

